#!/usr/bin/perl

# Author : Damien KROTKINE (damien@tuxfamily.org)
#
# Contributors : 
#
# Copyright (C) 2002 Damien KROTKINE (damien@tuxfamily.org)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

package Libconf::Glueconf;
use strict;
use vars qw(@ISA %EXPORT_TAGS @EXPORT_OK);
use MDK::Common::Various;

############ This feature is not used anymore. Maybe it's still a good idea?
my $current_section = '';
sub generateFunctions {
    my $ret = '';
    foreach my $element (@_) {
        if ($element->{type} eq 'KEY_VALUE') {
            if ($element->{value} eq 'BOOLEAN') {
                $ret .= 'sub ' . ($current_section ? ucfirst($current_section) . 'Is' : 'is') . ucfirst($element->{key}) . ' {' .
                  q|
    my $self = shift;
    MDK::Common::Various::text2bool($self->getAtom($self->findAtomPos({key => '| . $element->{key} . q|'}))->{value});
}

|;
                $ret .= 'sub ' . ($current_section ? ucfirst($current_section) . 'Set' : 'set') . ucfirst($element->{key}) . ' {' .
                  q|
    my ($self, $| . $element->{key} . q|) = @_;
    $self->editAtom(-1, {key => '| . $element->{key} . q|', value => MDK::Common::Various::bool2yesno($| . $element->{key} . q|)});
}

|;
            } else {
                $ret .= 'sub ' . ($current_section ? ucfirst($current_section) . 'Get' : 'get') . ucfirst($element->{key}) . ' {' .
                  q|
    my $self = shift;
    $self->getAtom($self->findAtomPos({key => '| . $element->{key} . q|'}))->{value};
}

|;
                $ret .= 'sub ' . ($current_section ? ucfirst($current_section) . 'Set' : 'set') . ucfirst($element->{key}) . ' {' .
                  q|
    my ($self, $| . $element->{key} . q|) = @_;
    $self->editAtom(-1, {key => '| . $element->{key} . q|', value => $| . $element->{key} . q|});
}

|;
            }
        }
        if ($element->{type} eq 'SECTION') {
            $current_section .= $element->{section_name};
            $ret .= generateFunctions(@{$element->{content}});
        }
    }
    $ret .= q|sub getSections {
    my $self = shift;
    map { my $atom = $self->getAtom($_); $atom->{section_name} } ($self->findAtomPos({type => 'SECTION'}));
}

|;
}
############ 

1;
