#!/usr/bin/perl

# Author : Damien KROTKINE (damien@tuxfamily.org)
#
# Contributors : 
#
# Copyright (C) 2002 Damien KROTKINE (damien@tuxfamily.org)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

package Libconf::System::Postfix;
use strict;
use vars qw(@ISA);
use Libconf;
use Libconf::Glueconf::KeyValue;

@ISA = qw(Libconf);

sub new {
    my ($pkg) = @_;
    bless {
           main => new Libconf::Glueconf::KeyValue('/etc/postfix/main.cf'),
          }, $pkg;
}

sub readConf {
    my ($self) = @_;
    $self->{$_}->readConf foreach qw(main);
}

sub writeConf {
    my ($self) = @_;
    $self->{$_}->writeConf foreach qw(main);
}

1;
