#!/usr/bin/perl

# Author : Damien KROTKINE (damien@tuxfamily.org)
#
# Contributors : 
#
# Copyright (C) 2002 Damien KROTKINE (damien@tuxfamily.org)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

package Libconf::System::Users;
use strict;
use vars qw(@ISA);
use Libconf;
use Libconf::Glueconf::Passwd;
use MDK::Common::Func;

@ISA = qw(Libconf);

sub new {
    my ($pkg) = @_;
    bless new Libconf::Glueconf::Passwd('/etc/passwd'), $pkg;
#    bless {
#           files => new Libconf::Glueconf::Passwd('/etc/passwd'),
#          }, $pkg;
}

########## TODO ##########
#
# get users from files, nis or ldap.
# add a method to retrieve which type of identifications we use.
#
##########################

sub readConf {
    my ($self) = @_;
    $self->{libconf}->readConf;
}

sub writeConf {
    my ($self) = @_;
    $self->{libconf}->writeConf;
}

sub getUsersList {
    my ($self, $filter) = @_; #fliter is optional
    my @user_list = keys %$self;
    if (defined $filter) {
        ref($filter) eq 'CODE' or die 'the filter is not a reference on a function';
        @user_list = grep { $filter->($self->{$_}) } @user_list;
    }
    @user_list;
}

1;
